package com.nisum.offertransactionservice.service;

import com.nisum.offertransactionservice.converter.OfferConverter;
import com.nisum.offertransactionservice.converter.PEResponseToOfferTransactionResConverter;
import com.nisum.offertransactionservice.dao.OfferDao;
import com.nisum.offertransactionservice.model.OfferTransactionRequest;
import com.nisum.offertransactionservice.model.OfferTransactionResponse;
import com.nisum.offertransactionservice.model.PEResponse;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.concurrent.CompletableFuture;
import java.util.concurrent.ExecutionException;

@Service
public class OfferCallingPEService {
    @Autowired
    private OfferConverter offerConverter;

    @Autowired
    private OfferDao offerDao;
    @Autowired
    private PEResponseToOfferTransactionResConverter peResponseToOfferTransactionResConverter;

    public OfferTransactionResponse getDiscountedItemList(OfferTransactionRequest offerTransactionRequest){
        OfferTransactionResponse offerTransactionResponse = null;
        CompletableFuture<PEResponse> peResponseCompletableFuture = offerDao.callPE(offerConverter.apply(offerTransactionRequest));
        try {
           PEResponse peResponse = peResponseCompletableFuture.get();
           offerTransactionResponse = peResponseToOfferTransactionResConverter.apply(peResponse);
           return offerTransactionResponse;
        } catch (InterruptedException e) {
            e.printStackTrace();
        } catch (ExecutionException e) {
            e.printStackTrace();
        }
        return offerTransactionResponse;
    }
}
